//+------------------------------------------------------------------+
//|                                                     TSI_MACD.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_maximum 110
#property indicator_minimum -110
#property indicator_level1 0
//---- input parameters
extern int Fast = 8;
extern int Slow = 21;
extern int Signal = 5;
extern int First_R = 8;
extern int Second_S = 5;
extern int SignalPeriod = 5;
extern int Mode_Smooth = 2;
//---- buffers
double TSI_Buffer[];
double SignalBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0, TSI_Buffer);
   SetIndexBuffer(1, SignalBuffer);
   IndicatorShortName("TSI_MACD(" + Fast + ", " + Slow + ", " + Signal + "; " + 
                      First_R + ", " + Second_S + ", " + SignalPeriod + ")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
//----
   for(i = limit; i >= 0; i--)
   {
      double macd = iMACD(NULL, 0, Fast, Slow, Signal, PRICE_CLOSE, MODE_MAIN, i) - iMACD(NULL, 0, Fast, Slow, Signal, PRICE_CLOSE, MODE_MAIN, i+1);  
      double maca = MathAbs(macd);
      
      if (maca!=0)
            TSI_Buffer[i] = 100.0*iEma(iEma(macd,First_R,i,0),Second_S,i,1)/iEma(iEma(maca,First_R,i,2),Second_S,i,3);
      else  TSI_Buffer[i] = 0;
   }      
   for(i = limit; i >= 0; i--)  SignalBuffer[i] = iMAOnArray(TSI_Buffer, 0, SignalPeriod, 0, Mode_Smooth, i);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define emaInstances 4
double workEma[][emaInstances];
double iEma(double price, double eperiod, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //

   double alpha = 2.0 / (1.0+eperiod);
   workEma[r][instanceNo+0] = price;
   if (r>0)
          workEma[r][instanceNo+0] = workEma[r-1][instanceNo+0]+alpha*(price-workEma[r-1][instanceNo+0]);
   return(workEma[r][instanceNo+0]);
}
